package io.gmss.fiscad.implementations.infocad.parametre;

import io.gmss.fiscad.entities.infocad.parametre.TypeDomaine;
import io.gmss.fiscad.exceptions.BadRequestException;
import io.gmss.fiscad.exceptions.NotFoundException;
import io.gmss.fiscad.interfaces.infocad.parametre.TypeDomaineService;
import io.gmss.fiscad.repositories.infocad.parametre.TypeDomaineRepository;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Optional;

@Service
public class TypeDomaineServiceImpl implements TypeDomaineService {

    private final TypeDomaineRepository typeDomaineRepository;

    public TypeDomaineServiceImpl(TypeDomaineRepository typeDomaineRepository) {
        this.typeDomaineRepository = typeDomaineRepository;
    }

    @Override
    public TypeDomaine createTypeDomaine(TypeDomaine typeDomaine) throws BadRequestException {
        if (typeDomaine.getId() != null) {
            throw new BadRequestException("Impossible de créer un nouveau type de domaine ayant un id non null.");
        }
        return typeDomaineRepository.save(typeDomaine);
    }

    @Override
    public TypeDomaine updateTypeDomaine(Long id, TypeDomaine typeDomaine) throws NotFoundException {
        if (typeDomaine.getId() == null) {
            throw new BadRequestException("Impossible de mettre à jour un nouveau type de domaine ayant un id null.");
        }
        if (!typeDomaineRepository.existsById(typeDomaine.getId())) {
            throw new NotFoundException("Impossible de trouver le type de domaine spécifié dans notre base de données.");
        }
        return typeDomaineRepository.save(typeDomaine);
    }

    @Override
    public void deleteTypeDomaine(Long id) throws NotFoundException {
        Optional<TypeDomaine> typeDomaineOptional = typeDomaineRepository.findById(id);
        if (typeDomaineOptional.isPresent()) {
            typeDomaineRepository.deleteById(typeDomaineOptional.get().getId());
        } else {
            throw new NotFoundException("Impossible de trouver le type de domaine spécifié dans notre base de données.");
        }
    }

    @Override
    public Page<TypeDomaine> getTypeDomaineList(Pageable pageable) {
        return typeDomaineRepository.findAll(pageable);
    }

    @Override
    public List<TypeDomaine> getTypeDomaineList() {
        return typeDomaineRepository.findAll();
    }

    @Override
    public Optional<TypeDomaine> getTypeDomaineById(Long id) {
        if (typeDomaineRepository.existsById(id)) {
            return typeDomaineRepository.findById(id);
        } else {
            throw new NotFoundException("Impossible de trouver le type de domaine spécifié dans la base de données.");
        }

    }
}
